#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <string.h>
#include <netdb.h>
#include <stdio.h>

#define PORTNUMBER 12345

int main(int argc, char **argv)
{
	char buf[1024], res[100];
	int n, s, ns, len, boy;
	char hostname[64];
	struct hostent *hp;
	struct sockaddr_in name;
	
	if (argc < 2) {
			fprintf(stderr,"invalid number of arguments\n");
			exit(1);
		      }
	else {
		for (boy=0, n=1; n<argc; n++)
		{
			strcpy(buf+boy,argv[n]);
			boy += strlen(argv[n]);
		}
			buf[boy]=buf[boy+1]=0;
	     }

	if (gethostname(hostname, sizeof(hostname)) < 0) {
		perror("gethostname");
	exit(1);
	}

	if ((hp = gethostbyname(hostname)) == NULL) {
		fprintf(stderr, "unknown host: %s, \n", hostname);
		exit(1);
	}
	
        if ((s = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
                perror("socket");
                exit(1);
        }                 

	memset(&name, 0, sizeof(struct sockaddr_in));

	name.sin_family = AF_INET;
	name.sin_port   = htons(PORTNUMBER);
	memcpy(&name.sin_addr, hp->h_addr_list[0], hp->h_length);
	len 		= sizeof(struct sockaddr_in);

	if (connect(s, (struct sockaddr *) &name, len) < 0) {
		perror("connect");
		exit(1);
	}

	if (send(s, buf, boy, 0) < 0) {
			perror("send");
			exit(1);
	}

	shutdown(s,1);
	while ((n = read(s, res, 100)) > 0) {
		write(1, res, n);
		printf("\n");
	}

	shutdown(s,2);
	exit(0);
}
	
