/* INET socket verson */

/* Buket ULU */
/* 105330-5 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>

#define PORT 2737

void main(int argc, char* argv[]){
	int s,c;
	int num1,num2,sum;
	struct sockaddr_in * name;
	int addrlen;
	char buffer[250];
	struct hostent *hptr;

	if (argc!=4){
		exit(1);
	}
	
	/* Get information */
	if ((hptr=gethostbyname(argv[1]))==NULL){
		printf("Getting information about the server is failed.\n");
		exit(1);
	}
	
name=(struct sockaddr_in *)malloc(sizeof(&name));
name->sin_family=AF_INET;
name->sin_port=PORT;
addrlen=sizeof(&name);
 /* Create socket */
if ((s=socket(AF_INET,SOCK_STREAM,0))==-1) {
	printf("Cannot create a socket.\n");
	exit(1);
}
/* Connect it */
if (connect(s,(struct sockaddr *)name,addrlen)==-1){
	printf("Connection error.\n");
	close(s);
	exit(1);
}
sscanf(argv[2],"%d",&num1);
sscanf(argv[3],"%d",&num2);
sprintf(buffer,"%d %d",num1,num2);
printf("before sent\n");
/* Send data */
if (send(s,buffer,250,0)==-1){
	printf("Error while sending data.\n");
	exit(1);
}
printf("data send edildi\n");
/* Receive sum */
if (recv(s,buffer,250,0)==-1){
	printf("Error in receiving data.\n");
	exit(1);
}
printf("data recv edildi\n");
sscanf(buffer,"%d",&sum);
printf("SUM(%d,%d)==>%d\n",num1,num2,sum);

	
}
