/* UNIX socket version */

/* Buket ULU */
/* 105330-5 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>


void main(int argc, char* argv[]){
	int s,c;
	int num1,num2,sum;
	struct sockaddr_un * name;
	int addrlen;
	char buffer[250];

	if (argc!=3){
		exit(1);
	}

name=(struct sockaddr_un *)malloc(sizeof(&name));
name->sun_family=AF_UNIX;
strcpy(name->sun_path,".hw4");
addrlen=sizeof(&name);

 /* Create socket */
if ((s=socket(AF_UNIX,SOCK_STREAM,0))==-1) {
	printf("Cannot create a socket.\n");
	exit(1);
}
/* Connect it */
if (connect(s,(struct sockaddr *)name,addrlen)==-1){
	printf("Connection error.\n");
	exit(1);
}
sscanf(argv[1],"%d",&num1);
sscanf(argv[2],"%d",&num2);
sprintf(buffer,"%d %d",num1,num2);
/* Send data */
if (send(s,buffer,250,0)==-1){
	printf("Error while sending data.\n");
	exit(1);
}
/* Receive sum */
if (recv(s,buffer,250,0)==-1){
	printf("Error in receiving data.\n");
	exit(1);
}
sscanf(buffer,"%d",&sum);
printf("SUM(%d,%d)==>%d\n",num1,num2,sum);

	
}
