#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h> 

#define PORTNO 21000

void error(char *msg)
{
    perror(msg);
    exit(0);
}

int main(int argc, char *argv[])
{
    int sockfd, portno, n,i,j;
    struct sockaddr_in serv_addr;
    struct hostent *server;

    char buffer[256];
    if (argc != 5) {
       fprintf(stderr,"usage %s hostname integer operand integer\n", argv[0]);
       exit(0);
    }
    portno=PORTNO;
   
    sockfd = socket(AF_INET, SOCK_STREAM, 0);
    if (sockfd < 0) 
        error("ERROR opening socket");
    server = gethostbyname(argv[1]);
    if (server == NULL) {
        fprintf(stderr,"ERROR, no such host\n");
        exit(0);
    }
    bzero((char *) &serv_addr, sizeof(serv_addr));
    serv_addr.sin_family = AF_INET;
    bcopy((char *)server->h_addr, 
         (char *)&serv_addr.sin_addr.s_addr,
         server->h_length);
    serv_addr.sin_port = htons(portno);
    if (connect(sockfd,&serv_addr,sizeof(serv_addr)) < 0) 
        error("ERROR connecting");
    bzero(buffer,256);
  
    strcpy(buffer,argv[2]);
       strcat(buffer,argv[3]);
         strcat(buffer,argv[4]);
     
        
    n = write(sockfd,buffer,strlen(buffer));
    if (n < 0) 
         error("ERROR writing to socket");
    bzero(buffer,256);
    n = read(sockfd,buffer,255);
    if (n < 0) 
         error("ERROR reading from socket");
    printf("sonuc: ");
    for(i=0,j=strlen(buffer); j>i;j--)
    printf("%c",buffer[j-1]);
    printf("\n");
    
    return 0;
}
