#include<sys/types.h>
#include<sys/stat.h>
#include<fcntl.h>
#include<unistd.h>
#include<wait.h>
#include<stdio.h>
#include<string.h>

#define FIFONAME "myfifo"

int main(int argc, char** argv) {

 int fd;
 char str1[20], str2[10], dummy[2];


  strcpy (str1, argv[1]);
  strcpy (str2, argv[2]); 

  strcat (str1, " ");
  strcat (str1, str2);


  unlink(FIFONAME);             /*any old FIFO is removed*/

  if (mkfifo(FIFONAME, 0666) < 0) {   /*create intended FIFO*/
     perror ("mkfifo");
     exit(1);
  }
       
  if ((fd = open (FIFONAME, O_WRONLY)) < 0) {
     perror("open");
     exit(1);
  }                   /* open FIFO for writing */ 

  write (fd, str1, 20); /* writes to FIFO */

  /*child process writes and closes the FIFO, and parent process reopens it
    for reading */

  close(fd);

  if ((fd = open (FIFONAME, O_RDONLY)) < 0) {
     perror("open");
     exit(1);
  }                   /* open FIFO for reading */ 

  read(fd, dummy, 15); 
  printf("Returned result is : %s\n", dummy);

  close(fd);
  unlink (FIFONAME);

  exit(0);

} 
