#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <string.h>
#include <stdio.h>

#define SOCKETNAME "mysocket"
#define SOCKET "socket"

int main(void)
{ char buf[1024],c[5];
  int i,j,n,s,ns,len,i1,i2,i3;
  struct sockaddr_un name;

  unlink(SOCKETNAME);
  if ((s=socket(AF_UNIX,SOCK_STREAM,0))<0)
  { perror("socket");
    exit(1);
  }
  memset(&name,0,sizeof(struct sockaddr_un));
  name.sun_family=AF_UNIX;
  strcpy(name.sun_path,SOCKETNAME);
  len=sizeof(name.sun_family)+strlen(name.sun_path);
  if (bind(s,(struct sockaddr *) &name,len)<0)
  { perror("bind");
    exit(1);
  }
  if (listen(s,5)<0)
  { perror("listen");
    exit(1);
  }
  if ((ns=accept(s,(struct sockaddr *) &name,&len))<0)
  { perror("accept");
    exit(1);
  }
  n=recv(ns,buf,sizeof(buf),0);
  sscanf(buf,"%d %d",&i1,&i2);
  i3=i1+i2;
  printf("%d %d %d",i1,i2,i3);
  fflush(stdout);
  sprintf(c,"%d",i3);
  printf("\n%s",c);
  close(ns);
  close(s);

  wait(1);

  s=socket(AF_UNIX,SOCK_STREAM,0);
  memset(&name,0,sizeof(struct sockaddr_un));
  name.sun_family=AF_UNIX;
  strcpy(name.sun_path,SOCKET);
  len=sizeof(name.sun_family)+strlen(name.sun_path);
  connect(s,(struct sockaddr *) &name,len);
  send(s,c,sizeof(c),0);
  close(s);
  
  return 0;
}
