  #include<sys/types.h>
  #include<sys/socket.h>
  #include<string.h>
  #include<sys/un.h>
  #include<stdio.h>

  #define SOCKETNAME "mysocket"

  int main (int argc, char *argv[])
  {
   int n, s, ns, len;
   char buf[1024], bbb[1024];
   struct sockaddr_un name;

   if (argc != 3)
    {
     fprintf(stderr,"invalid number of arguments to function %s\n",argv[0]);
     exit(1);
    }

   if ((s = socket(AF_UNIX, SOCK_STREAM, 0)) < 0)
     {
      perror("socket");
      exit(1);
     }

   memset(&name, 0, sizeof(struct sockaddr_un));

   name.sun_family = AF_UNIX;
   strcpy(name.sun_path, SOCKETNAME);
   len = sizeof(name.sun_family) + strlen(name.sun_path);

   if (connect(s, (struct sockaddr *) &name, len) < 0)
     {
      perror("connect");
      exit(1);
     }

   strcpy(buf, argv[1]);
   strcat(buf, " ");
   strcat(buf, argv[2]);
   strcat(buf, "\0");

   if (strlen(buf) > 0)
     {
      if (send(s, buf, strlen(buf), 0) < 0)
        {
         perror("send");
         exit(1);
        }
     }

   if ((n = recvfrom(s, buf, sizeof(buf),0,(struct sockaddr *)&name,&len)) > 0)
     strncpy(bbb, buf, n);

   printf("%s + %s = %s\n", argv[1], argv[2], bbb);

   close(s);

   exit(0);
  }
