#include"main.h"

#define MAXCONNECT      4

int main(int argc,char *argv[]) {
        struct sockaddr_in addr;
        int socket_res,bind_res,client_res;
        int send_res,recv_res;                                                          int pid,len;
        char buff[BUFFERSIZE];
        memset(&addr,0,sizeof(struct sockaddr_in));

        addr.sin_family=AF_INET;
        addr.sin_port = htons(atoi(argv[1]));
        socket_res = socket(AF_INET,SOCK_STREAM,0);
        if (socket_res == -1) {
                perror("socket:");
                exit(1);
        }
        len = sizeof(addr);
        bind_res = bind(socket_res,(struct sockaddr*) &addr,len);
        if (bind_res == -1) {
                perror("bind:");
                exit(2);
        }
        if (listen(socket_res,MAXCONNECT) == -1) {
                perror("listen:");
                exit(3);
        }

        while (client_res = accept(socket_res,(struct sockaddr*) &addr,&len)) {
                if (client_res == -1) {
                        perror("accept:");
                        exit(4);
                }
                pid = fork();
                if (pid == -1) {
                        perror("fork:");
			close(socket_res);
			close(client_res);
                        exit(5);
                }
                if (!pid) {
                        int sum;
                        int num1,num2;
                        close(socket_res);
                        recv_res = recv(client_res,buff,sizeof(buff),0);
                        if (recv_res == -1) {
                                perror("receive:");
                        }
                        sscanf(buff,"%d %d",&num1,&num2);
                        sum = num1 + num2;
                        sprintf(buff,"%d",sum);
                        send_res = sendto(client_res,buff,strlen(buff)+1,0,
                                          (struct sockaddr *)&addr,len);
                        if (send_res < 0) {
                                perror("send:");
                        }                         
                        exit(0);
                }
                else {
                        close(client_res);
                        wait(NULL);
                }
        }
        return 0;
} 
