#include"main.h"

#define MAXCONNECT      4

int main(int argc,char *argv[]) {
        struct sockaddr_un addr;
        int socket_res,bind_res,client_res;
        int send_res,recv_res,opt_res;
	int pid,len,opt;
	int num1,num2;
        char buff[BUFFERSIZE];

	unlink(SUN_PATH);
        memset(&addr,0,sizeof(struct sockaddr_un));
        addr.sun_family=AF_UNIX;
	strcpy(addr.sun_path,SUN_PATH);
//        addr.sun_port = htons(atoi(argv[1]));
        socket_res = socket(AF_UNIX,SOCK_STREAM,0);
        if (socket_res == -1) {
                perror("socket:");
                exit(1);
        }
	opt =1;
	opt_res=setsockopt(socket_res,SOL_SOCKET,SO_REUSEADDR,&opt,sizeof(opt));
	if (opt_res == -1) {
		perror("setsockopt:");
		exit(2);
	}
        len = sizeof(addr);
        bind_res = bind(socket_res,(struct sockaddr*) &addr,len);
        if (bind_res == -1) {
                perror("bind:");
                exit(3);
        }
        if (listen(socket_res,MAXCONNECT) == -1) {
                perror("listen:");
                exit(3);
        }

        while (client_res = accept(socket_res,(struct sockaddr*) &addr,&len)) {
                if (client_res == -1) {
                        perror("accept:");
                        exit(4);
                }
                pid = fork();
                if (pid == -1) {
                        perror("fork:");
			close(socket_res);
			close(client_res);
                        exit(5);
                }
                if (!pid) {
                        int sum;
                        close(socket_res);
                        recv_res = recv(client_res,buff,sizeof(buff),0);
                        if (recv_res == -1) {
                                perror("receive:");
                        }
                        sscanf(buff,"%d %d",&num1,&num2);
                        sum = num1 + num2;
                        sprintf(buff,"%d",sum);
                        send_res = sendto(client_res,buff,strlen(buff)+1,0,
                                          (struct sockaddr *)&addr,len);
                        if (send_res < 0) {
                                perror("send:");
                        }                         
                        exit(0);
                }
                else {
                        close(client_res);
                        wait(NULL);
                }
        }
        return 0;
} 
