#include<sys/types.h>
#include<sys/socket.h>
#include<string.h>
#include<netinet/in.h>
#include<netdb.h>
#include<stdio.h>

#define PORTNUMBER 12345

int main(int argc, char *argv[])
 {
 int	n, s, len, i, ns;
 char	buf[16], arg1[10], arg2[10];
 char	hostname[64];
 struct	hostent *hp;
 struct	sockaddr_in name;

 if (argc != 3)
   {
   printf("usage : %s arg1 arg2\n", argv[0]);
   exit(1);
   }

 if (gethostname(hostname, sizeof(hostname)) < 0)
   {
   perror("gethostname");
   exit(1);
   }

 if ((hp=gethostbyname(hostname)) == NULL)
   {
   fprintf(stderr, "unknown host: %s.\n", hostname);
   exit(1);
   }

 if ((s=socket(AF_INET, SOCK_STREAM, 0)) < 0)
   {
   perror("socket");
   exit(1);
   }

 memset(&name, 0, sizeof(struct sockaddr_in));

 name.sin_family=AF_INET;
 name.sin_port=htons(PORTNUMBER);
 memcpy(&name.sin_addr, hp->h_addr_list[0], hp->h_length);
 len=sizeof(struct sockaddr_in);

 if (connect(s, (struct sockaddr *) &name, len) < 0)
   {
   perror("connect");
   exit(1);
   }

 strcpy(arg1, argv[1]);
 if (send(s, arg1, 10, 0) < 0)
   {
   perror("send");
   exit(1);
   }

 strcpy(arg2, argv[2]);
 if (send(s, arg2, 10, 0) < 0)
   {
   perror("send");
   exit(1);
   }
   
 if (recv(s, buf, 10, 0) < 0)
   {
   perror("send");
   exit(1);
   }
 printf("result is %d\n", atoi(buf));

 close(s);
 exit(0);
 }
