#include<sys/types.h>
#include<sys/socket.h>
#include<string.h>
#include<netinet/in.h>
#include<sys/un.h>
#include<stdio.h>

#define SOCKETNAME "mysocket"

int main(int argc, char *argv[])
 {
 int	n, s, len, i, ns;
 char	buf[16], arg1[10], arg2[10];
 struct	sockaddr_un name;

 if (argc != 3)
   {
   printf("usage : %s arg1 arg2\n", argv[0]);
   exit(1);
   }

 if ((s=socket(AF_UNIX, SOCK_STREAM, 0)) < 0)
   {
   perror("socket");
   exit(1);
   }

 memset(&name, 0, sizeof(struct sockaddr_un));

 name.sun_family=AF_UNIX;
 strcpy(name.sun_path, SOCKETNAME);
 len=sizeof(name.sun_family) + strlen(name.sun_path);

 if (connect(s, (struct sockaddr *) &name, len) < 0)
   {
   perror("connect");
   exit(1);
   }

 strcpy(arg1, argv[1]);
 if (send(s, arg1, 10, 0) < 0)
   {
   perror("send");
   exit(1);
   }

 strcpy(arg2, argv[2]);
 if (send(s, arg2, 10, 0) < 0)
   {
   perror("send");
   exit(1);
   }
   
 if (recv(s, buf, 10, 0) < 0)
   {
   perror("send");
   exit(1);
   }
 printf("result is %d\n", atoi(buf));

 close(s);
 exit(0);
 }
