#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>

#define FIFONAME "myfifo"

int main(int argc,char * argv[]){
	int n,fd;
	int num1,num2,sum;
	char buffer[1024];
	/* Open the FIFO for writing. It was created by the server. */
	if ((fd=open(FIFONAME,O_RDWR))<0){
		perror("Open");
		exit(1);
	}
	sscanf(argv[1],"%d",&num1);
	sscanf(argv[2],"%d",&num2);
	sprintf(buffer,"%d %d",num1,num2);
	if (write(fd,buffer,strlen(buffer))<0){
		perror("Write");
	        close(fd);
		exit(1);
	}
	bzero(buffer,100);
	if (read(fd,buffer,100)<0){
		perror("Read");
		close(fd);
		exit(1);
	}
	printf("SUM(%d,%d)=%s\n",num1,num2,buffer);
	close(fd);
	return 1;
}
	
