#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>


#define PORT 2737

void main(){
	int s,c,n;
	struct sockaddr_in name;
	int addrlen;
	char buffer[250];
	int pid,o;	
	char host[31];
	struct hostent * hptr;
	int port=PORT;

 	/* Create the socket. */
	if ((s=socket(AF_INET,SOCK_STREAM,0))==-1) {
		perror("Create socket");
		exit(1);
	}

	memset(&name,0,sizeof(struct sockaddr_in));

	name.sin_family=AF_INET;
	name.sin_port=htons(port);
	addrlen=sizeof(name);
	/* Use the wildcard address. */
	n=INADDR_ANY;
	memcpy(&name.sin_addr,&n,sizeof(long));

	/* Bind the socket to the address */
	if (bind(s,(struct sockaddr *)&name,addrlen)<0){
		perror("Bind");
		exit(1);
	}
	/* Listen for connections*/
	if (listen(s,3)<0){
		perror("Listen");
		exit(1);
	}
	while(1){
		/* Accept a connection */
		if ((c=accept(s,(struct sockaddr *)&name,&addrlen))<0){
			perror("Accept");
			exit(1);
		}
		/* FORK */
		if ((pid=fork())==-1){
			printf("Error in fork.\n");
			close(s); close(c);
			exit(1);
		}
		if (pid==0){ /* Child */
			int sum,num1,num2;
			close(s);
			if (recv(c,buffer,250,0)==-1){
				perror("Recv");
				exit(1);
			}
			sscanf(buffer,"%d %d",&num1,&num2);
			printf("num1==>%d, num2==>%d\n",num1,num2);
			sum=num1+num2;
			sprintf(buffer,"%d",sum);
			if (send(c,buffer,250,0)==-1){
				perror("Send");
				exit(1);
			}
			exit(0);
		}
		else{ /* Parent */
			close(c);
			wait(NULL);
		}

	}
}
