/* Ozgur SANLI / 106189-4	*/
/* CENG-332 / HW#4		*/
/* FIFO - Client		*/

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define READ_FIFO	"/tmp/.fifo_w.332"
#define WRITE_FIFO	"/tmp/.fifo_r.332"

void error(char *msg)
{
	perror(msg);
	exit(1);
}

int main(int argc, char **argv)
{
	char buffer[256];
	int fdin, fdout;
	int num1, num2;


	if (argc < 3) {
		fprintf(stderr, "Usage: %s <num1> <num2>\n", argv[0]);
		exit(0);
	}

	num1 = atoi(argv[1]);
	num2 = atoi(argv[2]);

	if ((fdout = open(WRITE_FIFO, O_WRONLY)) < 0)
		error("open");

	if ((fdin = open(READ_FIFO, O_RDONLY)) < 0)
		error("open");

#ifdef DEBUG
	printf("Opened the fifo  files\n");
#endif

	fprintf(stdout, "Press any key to get the sum...");
	fgetc(stdin);

	bzero(buffer, 256);
	sprintf(buffer, "%d %d", num1, num2);
	write(fdout, buffer, strlen(buffer));

#ifdef DEBUG
	printf("Sent the numbers to the server\n");
#endif
	bzero(buffer, 256);
	read(fdin, buffer, 255);
	sscanf(buffer, "%d", &num1);
	fprintf(stdout, "The result is: %d\n", num1);

#ifdef DEBUG
	printf("Has gotten the result back\n");
#endif
	close(fdin);
	close(fdout);
	return 0;
}
