#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <netdb.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <sys/un.h>

int main(int argc, char *argv[]){
 struct sockaddr_un their_addr; 
 int sockfd;
 int p1, p2, result; 

 if (argc != 4){
 	fprintf(stderr, "Usage: client <hostname> <p1> <p2>\n");
 	exit(1);
 };
 p1= atoi(argv[2]);
 p2= atoi(argv[3]);
 printf("Numbers to be added: %d %d",p1,p2);

 if ((sockfd=socket(AF_UNIX,SOCK_STREAM,0))== -1){
 	perror("socket");
 	exit(1);
 };
 their_addr.sun_family=AF_UNIX;  
 strcpy(their_addr.sun_path,"/tmp/unixsocket"); 
 
 if (connect(sockfd,(struct sockaddr *)&their_addr,sizeof(struct sockaddr))== -1){
 	perror("connect");
 	exit(1);
 };
 if (send(sockfd,&p1,sizeof(int),0)== -1)
 	perror("send");                                 
 if (send(sockfd,&p2,sizeof(int),0)== -1)
 	perror("send");                                 
 if ((recv(sockfd,&result,sizeof(int),0))== -1) {
 	perror("recv");
 	exit(1);
 };

 printf("\nResult	     	   : %d\n",result);
 
 close(sockfd);
 return 0;
}

