#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <sys/wait.h>
#include <sys/un.h>
#define LOGPOINT 10

int main() {
 struct sockaddr_un my_addr;  
 struct sockaddr_un their_addr;  
 int sockfd, new_fd; 
 int p1, p2;
 int result;
 int sun_size;

 if ((sockfd=socket(AF_UNIX,SOCK_STREAM,0))== -1){
 	perror("socket");
 	exit(1);
 };
 system("rm -rf /tmp/unixsocket");
 my_addr.sun_family = AF_UNIX;	
 strcpy(my_addr.sun_path,"/tmp/unixsocket"); 

 if (bind(sockfd,(struct sockaddr *)&my_addr,sizeof(struct sockaddr))== -1){
 	perror("bind");
 	exit(1);
 };
 if (listen(sockfd,LOGPOINT)== -1){
 	perror("listen");
 	exit(1);
 };
 printf("\nServer Started: \n");
 while (1){  
 	sun_size=sizeof(struct sockaddr_un);
 	if ((new_fd=accept(sockfd,(struct sockaddr *)&their_addr,&sun_size))== -1){
        	perror("accept");
        	continue;
     	};
 	if (!fork()){
        	if (recv(new_fd,&p1,sizeof(int),0)== -1){
           		perror("recv");
           		exit(1);
        	};
        	if (recv(new_fd,&p2,sizeof(int),0)== -1){
           		perror("recv");
           		exit(1);
        	};
        	result= p1+p2;
        	if (send(new_fd,&result,sizeof(int),0)== -1)
           		perror("send");
        	close(new_fd);
        	exit(0);
     	};
        close(new_fd);   
    	while (waitpid(-1,NULL,WNOHANG)>0);
 };
 return 0;
}

