/*********************** Fikret Can, 05/05/2000 *****************************/
/*********************** e-mail  : e1061472@ceng.metu.edu.tr ****************/
/*********************** FILE    : client.c                  ****************/ 
/*********************** COMPILE : gcc client.c -o client    ****************/
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <sys/file.h>

#define PIPE "pipe"

int main(int argc, char *argv[])
{
  int fd;
  int num1, num2, result; 

  if (argc != 3) {
     fprintf(stderr, "usage: client <num1> <num2>\n");
     exit(1);
  }

  num1 = atoi(argv[1]);
  num2 = atoi(argv[2]);

  unlink(PIPE);
  if (mknod(PIPE, S_IFIFO, 0) == -1) {
      perror("mknod");
      exit(1);
  }

  chmod(PIPE,0660);
  fd = open(PIPE, O_WRONLY);

  if (write(fd, (char *)&num1, sizeof(int)) == -1) {
     perror("write");                                 
     exit(1);
  }
  sleep(2);

  fd = open(PIPE, O_WRONLY);
  if (write(fd, (char *)&num2, sizeof(int)) == -1) {
    perror("write");                                 
    exit(1);
  }
  sleep(2);

  fd = open(PIPE, O_RDONLY);
  if (read(fd, (char *)&result, sizeof(int)) == -1) {
     perror("read");
     exit(1);
  }
  printf("\nclient: Received: %d\n\n", result);
 
  close(fd);

  return 0;
}

