#include<sys/types.h>
#include<sys/socket.h>
#include<netinet/in.h>
#include<fcntl.h>
#include<unistd.h>
#include<string.h>
 
#define PORTNUMBER 12345

int main(void)
{
 char result;
 char buf[2];
 int sock,acc_clnt;
 int len,wild;
 struct sockaddr_in name;
 
 if ((sock = socket (AF_INET,SOCK_STREAM,0)) < 0)
  {                
   perror ("socket");
   exit(1);
  } /* creates the intended socket*/
 
 memset (&name,0,sizeof(struct sockaddr_in));
       /* create server address*/ 
 name.sin_family = AF_INET;
 name.sin_port = htons (PORTNUMBER);
 len = sizeof (struct sockaddr_in);
 
 wild = INADDR_ANY;                   /* use wildcard */  
 memcpy (&name.sin_addr,&wild,sizeof(long));
 
 if (bind (sock,(struct sockaddr *) &name,len) < 0)
  {
   perror ("bind");
   exit(1);
  }
 
 if (listen (sock,5) < 0)
  {
   perror ("listen");
   exit(1);
  }
  
 if ((acc_clnt = accept (sock,(struct sockaddr *) &name , &len)) < 0 )
  {
   perror ("accept");
   exit(1);
  } 
 
  /*read from socket*/
 recv (acc_clnt , buf, 2, 0); /* data received from client*/
 
 
 result = buf[0]+buf[1];
 
 send(acc_clnt,&result,1,0); /* result sent to client */
 
 close(sock);
 close(acc_clnt);

 exit(0);
 
}
 

