#include<sys/types.h>
#include<sys/stat.h>
#include<fcntl.h>
#include<unistd.h>
#include<wait.h>
#include<stdio.h>
#include<string.h>
#include<stdlib.h>

#define FIFONAME "myfifo"

int main (void) {

 int op1, op2, i;
 int fd;
 char dummy[20], t[20], s1[10], s2[10];

 system ("clear");

 if ((fd = open (FIFONAME, O_RDONLY)) < 0) {
     perror("open");
     exit(1);
  }                   /* open FIFO for reading */

 read (fd, dummy, 20);
 close(fd);

 s1[0] = '\0';
 for (i = 0; '0' <= dummy[i] && dummy[i] <= '9' ; i++){
      t[0] = dummy[i];
      t[1] = '\0';
      strcat(s1,t);
      
 }
 s1[i] = '\0';
 op1 = atoi (s1);

 s2[0] = '\0';
 for (i++; '0'<=  dummy[i] && dummy[i] >= '0'  ; i++){
      t[0] = dummy[i];
      t[1] = '\0';
      strcat(s2,t);
      
 }
 s2[i] = '\0';
 op2 = atoi (s2);

 printf("server has found that : op1 = %d, op2 = %d \n\n", op1, op2);

 op1 += op2;
 t[1] = '\0';
 dummy[0] = '\0';

 while (op1 != 0) {
      op2 = op1 % 10;
      t[0] = op2 + 48;
      strcat (dummy, t);
      op1 /= 10;  
 }

 op1 = strlen(dummy);
 
 for(i = op1 - 1; i >= 0; i--)
     t[op1 - 1 - i] = dummy[i];

 t[op1] = '\0';

 if ((fd = open (FIFONAME, O_WRONLY)) < 0) {

     perror("open");
     exit(1);
  }                   /* open FIFO for writing */

 write(fd, t, op1+1);
 
 close (fd);         /*close FIFO */
 exit(0);
 
}
