#include <netinet/in.h>
#include <netdb.h>
#include <errno.h>
#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <sys/wait.h>

struct sockaddr_in svr_addr;
struct hostent *hostp;
int fd_svr,op1,op2,sum;
char data[1000];
int port;

void main(int argc,char **argv) {

	if (argc!=5) {
		fprintf(stderr,"\nUsage: client servername port op1 op2\n");
		exit(1);
	}

	sscanf(argv[2],"%d",&port);
	hostp=gethostbyname(argv[1]);
	memset(&svr_addr,0,sizeof(svr_addr));
	memcpy((char *) &svr_addr.sin_addr,hostp->h_addr,hostp->h_length);
	svr_addr.sin_family=hostp->h_addrtype;
	svr_addr.sin_port=htons(port);

	fd_svr=socket(AF_INET,SOCK_STREAM,0);
	connect(fd_svr,(struct sockaddr *)&svr_addr,sizeof(svr_addr));
	sscanf(argv[3],"%d",&op1);
	sscanf(argv[4],"%d",&op2);
	sprintf(data,"%d %d",op1,op2);
	sendto(fd_svr,data,strlen(data)+1,0,(struct sockaddr *) &svr_addr,sizeof(svr_addr));
	recv(fd_svr,data,sizeof(data),0);
	sscanf(data,"%d",&sum);
	fprintf(stderr,"%d+%d=%d\n",op1,op2,sum);
}
