#include <errno.h>
#include <unistd.h>
#include <stdio.h>
#include <string.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <sys/un.h>
#include <sys/wait.h>

#define SOCKETFILE		"Socket"

struct sockaddr_un svr_addr;
int fd_svr,op1,op2,sum;
char data[1000];

void main(int argc,char **argv) {

	if (argc!=3) {
		fprintf(stderr,"\nUsage: client op1 op2\n");
		exit(1);
	}
	memset(&svr_addr,0,sizeof(svr_addr));
	svr_addr.sun_family=AF_UNIX;
	strcpy(svr_addr.sun_path,SOCKETFILE);
	fd_svr=socket(AF_UNIX,SOCK_STREAM,0);
	connect(fd_svr,(struct sockaddr *)&svr_addr,sizeof(svr_addr));
	sscanf(argv[1],"%d",&op1);
	sscanf(argv[2],"%d",&op2);
	sprintf(data,"%d %d",op1,op2);
	send(fd_svr,data,strlen(data)+1,0);
	recv(fd_svr,data,sizeof(data),0);
	sscanf(data,"%d",&sum);
	fprintf(stderr,"%d+%d=%d\n",op1,op2,sum);
}
