  #include <fcntl.h>
  #include <stdio.h>
  #include <stdlib.h>
  #include <string.h>
  #include <sys/stat.h>
  #include <sys/types.h>

  #define FIFONAME  "myfifo"

  int main (int argc, char *argv[])
  {
   int n, fd;
   char buf[100];

   if (argc != 3)
     fprintf(stderr, "%s: wrong number of argument\n",argv[0]);

   if ((fd = open(FIFONAME, O_RDWR)) < 0 )
     {
      perror("open");
      exit(1);
     }

   strcpy(buf, argv[1]);
   strcat(buf, " ");
   strcat(buf, argv[2]);
   strcat(buf, "\0");

   write(fd, buf, strlen(buf));

   n = read(fd, buf, sizeof(buf));

   buf[n] ='\0';
   printf("%s + %s = %s\n",argv[1], argv[2], buf);

   close(fd);
   exit(0);
  }
