  #include<sys/types.h>
  #include<sys/socket.h>
  #include<netinet/in.h>
  #include<string.h>
  #include<netdb.h>
  #include<stdio.h>

  #define PORTNUM 9990

  int main (int argc, char *argv[])
  {
   int n, s, ns, len;
   char buf[1024];
   char hostname[64];
   struct hostent *hp;
   struct sockaddr_in name, name2;

   if (argc != 4)
     {
      fprintf(stderr,"invalid number of arguments to function %s\n",argv[0]);
      exit(1);
     }

   strcpy(hostname, argv[1]);

   if ((hp = gethostbyname(hostname)) == NULL)
     {
      fprintf(stderr, "unknown host: %s.\n", hostname);
      exit(1);
     }

   unlink(PORTNUM);

   if ((s = socket(AF_INET, SOCK_STREAM, 0)) < 0)
     {
      perror("socket");
      exit(1);
     }

   memset(&name, 0, sizeof(struct sockaddr_in));

   name.sin_family = AF_INET;
   name.sin_port = htons(PORTNUM);
   memcpy(&name.sin_addr, hp -> h_addr_list[0], hp -> h_length);
   len = sizeof(struct sockaddr_in);

   if (connect(s, (struct sockaddr *) &name, len) < 0)
     {
      perror("connect");
      exit(1);
     }

   strcpy(buf, argv[2]);
   strcat(buf, " ");
   strcat(buf, argv[3]);
   strcat(buf, "\0");

   if (strlen(buf) > 0)
     if (send(s, buf, strlen(buf), 0) < 0)
       {
        perror("send");
        exit(1);
       }

//   if ((n = recvfrom(s, buf, sizeof(buf), 0,(struct sockaddr *)&name,&len)) > 0)
   if ((n = recv(s, buf, sizeof(buf), 0)) > 0)
     strncpy(hostname, buf, n);

   printf("%s + %s = %s\n",argv[2], argv[3], hostname);

   shutdown(s, 2);
   exit(0);
  }
