#include<sys/types.h>
#include<sys/stat.h>
#include<fcntl.h>
#include<stdio.h>
#include<string.h>

#define FIFONAME "myfifo"

int main(int argc, char *argv[])
 {
 int  n, fd;
 char buf[16], arg1[10], arg2[10];

 if (argc != 3)
   {
   printf("usage : %s arg1 arg2\n", argv[0]);
   exit(1);
   }

 if ((fd=open(FIFONAME, O_RDWR)) < 0)
   {
   perror("open");
   exit(1);
   }

 strcpy(arg1, argv[1]);
 write(fd, arg1, 10, 0);

 strcpy(arg2, argv[2]);
 write(fd, arg2, 10, 0);

 read(fd, buf, 10, 0);
 printf("result is %d\n", atoi(buf));

 close(fd);
 exit(0);
 }
