#include<sys/types.h>
#include<sys/socket.h>
#include<sys/un.h>
#include<string.h>
#include<stdio.h>

#define SOCKETNAME "mysocket"

int main(void)
 {
 char	buf[16], c;
 int	f, n, s, ns, len, i, arg, arg1, arg2;
 struct	sockaddr_un name;

 unlink(SOCKETNAME);

 if ((s=socket(AF_UNIX, SOCK_STREAM, 0)) < 0)
   {
   perror("socket");
   exit(1);
   }

 memset(&name, 0, sizeof(struct sockaddr_un));

 name.sun_family=AF_UNIX;
 strcpy(name.sun_path, SOCKETNAME);
 len=sizeof(name.sun_family) + strlen(name.sun_path);


 if (bind(s, (struct sockaddr *) &name, len) < 0)
   {
   perror("bind");
   exit(1);
   }

   if (listen(s, 5) < 0)
     {
     perror("listen");
     exit(1);
     }

 while (1)
   {
   if ((ns=accept(s, (struct sockaddr *) &name, &len)) < 0)
     {
     perror("accept");
     exit(1);
     }

   if (fork() == 0)
     {
     recv(ns, buf, 10, 0);
     arg1=atoi(buf);

     recv(ns, buf, 10, 0);
     arg2=atoi(buf);

     arg=arg1+arg2;

     for (i=0; i<sizeof(int); ++i)
       {
       buf[sizeof(int)-i-1]=arg%10+'0';
       arg/=10;
       }
     buf[sizeof(int)]='\0';

     if (send(ns, buf, 10, 0) < 0)
       {
       perror("send");
       exit(1);
       }
     close(ns);
     exit(0);
     }
   }

 close(ns);
 close(s);
 exit(0);
 }
