/*Serkan Alimci*/
/* e1061324 */
/* Ceng 4 */

#include<stdio.h>
#include<stdlib.h>
#include<errno.h>
#include<string.h>
#include<sys/types.h>
#include<netinet/in.h>
#include<sys/socket.h>
#include<sys/wait.h>
 
#define PORT 1978
#define BACKLOG 10
#define BUFLEN 50

#define ADD '+'
#define SUB '-'
#define MUL '*'
#define DIV '/'

/*The following function converts a error free string to an integer */
int str_int(char *str)
{
 int i,j,res,mul;
 
 i=0;
 mul=1;
 if(str[0]=='-')
 {
  i=1;
  mul=-1;
 }
 else if(str[0]=='+')
       i=1;
 j=strlen(str);
 
 for(res=0;i<j;i++)
 {
  if(str[i]>='0' && str[i]<='9')
   res=res*10+str[i]-'0';
 }
 return mul*res;
}


int main(void)
{
 int sockfd,clientfd,size;
 int result,i,j;
 int  operand1,operand2;
 char operator;

 struct sockaddr_in server,client;
 char buffer[BUFLEN];
 char *bufptr;

 printf("Starting ...\n");

// Create a stream socket 
 if((sockfd=socket(AF_INET,SOCK_STREAM,0))==-1)
 {
  perror("socket");
  exit(1);
 }
 
 server.sin_family=AF_INET;
 server.sin_port=htons(PORT);
 server.sin_addr.s_addr=htonl(INADDR_ANY); // local machine address
 bzero(&(server.sin_zero),8);
 
// Bind the created socket to the port of local machine
 if(bind(sockfd,(struct sockaddr *)&server,sizeof(struct sockaddr))==-1)
 {
  perror("bind");
  exit(1);
 }

//listen from the socket
 if(listen(sockfd,BACKLOG)==-1)
 {
  perror("listen");
  exit(1);
 }

//This loop handles the incoming requests
 while(1)
 {
  size=sizeof(struct sockaddr_in);
  if((clientfd==accept(sockfd,(struct sockaddr *)&client,&size))==-1)
  {
   perror("accept");
   continue;
  }

  printf("server : got connection from %s\n",inet_ntoa(client.sin_addr));

  if(!fork())
  {
   if(recv(clientfd,buffer,BUFLEN,0)==-1)
    perror("recv");
   else 
   {
    for(i=0,j=strlen(buffer);i<j;i++)
     if(buffer[i]==' ')
      buffer[i]=0;

    operand1=str_int(buffer);
    i=strlen(buffer)+1;
    bufptr=buffer+i;
    operand2=str_int(bufptr);
    i=strlen(bufptr)+1;
    bufptr+=i;
    operator=bufptr[0];
    switch(operator)
    {
     case ADD : result=operand1+operand2;break;
     case SUB : result=operand1-operand2;break;
     case MUL : result=operand1*operand2;break;
     case DIV : result=operand1/operand2;break;
    }
    sprintf(buffer,"%d",result);
    if(send(clientfd,buffer,strlen(buffer)+1,0)==-1)
     perror("send");
   }
   close(clientfd);
   exit(0);
  }
  close(clientfd);
  while(waitpid(-1,NULL,WNOHANG)>0);
 }
 
 close(sockfd);
 return 0;
}
