#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <unistd.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <string.h>

#define PORT 2737

void main(int argc, char* argv[]){
	int s,c;
	int num1,num2,sum;
	struct sockaddr_in  name;
	int addrlen;
	char buffer[250];
	struct hostent *hptr;
	int port=PORT;

	if (argc!=4){
		exit(1);
	}
	
	/* Get information */
	if ((hptr=gethostbyname(argv[1]))==NULL){
		fprintf(stderr,"unknown host: %s.\n",argv[1]);
		exit(1);
	}
 	/* Create a socket in the INET domain */
	if ((s=socket(AF_INET,SOCK_STREAM,0)) < 0) {
		perror("Create socket");
		exit(1);
	}
	
	memset(&name,0,sizeof(struct sockaddr_in));
	name.sin_family=AF_INET;
	name.sin_port=htons(port);
	memcpy(&name.sin_addr,hptr->h_addr_list[0],hptr->h_length);
	addrlen=sizeof(name);

	/* Connect to the server */
	if (connect(s,(struct sockaddr *)&name,addrlen) <0){
		printf("Connection error.\n");
		close(s);
		exit(1);
	}
	sscanf(argv[2],"%d",&num1);
	sscanf(argv[3],"%d",&num2);
	sprintf(buffer,"%d %d",num1,num2);
	/* Send data */
	if (send(s,buffer,strlen(buffer),0)==-1){
		perror("Send");
		exit(1);
	}
	/* Receive sum */
	if (recv(s,buffer,250,0)==-1){
		perror("Recv");
		exit(1);
	}
	sscanf(buffer,"%d",&sum);
	printf("SUM(%d,%d)==>%d\n",num1,num2,sum);

	
}
