#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>


void main(){
	int s,c;
	struct sockaddr_un * name;
	int addrlen;
	char buffer[250];
	int pid,o;	
name=(struct sockaddr_un *)malloc(sizeof(&name));
name->sun_family=AF_UNIX;
strcpy(name->sun_path,".hw4");
addrlen=sizeof(&name);

unlink(".hw4");
unlink(".h");

 /* Create socket */
if ((s=socket(AF_UNIX,SOCK_STREAM,0))==-1) {
	printf("Cannot create a socket.\n");
	exit(1);
}
if (setsockopt(s,SOL_SOCKET,SO_REUSEADDR,&o,sizeof(o))==-1){
	printf("Error while setting the socket option.\n");
	exit(1);
}

/* Bind it */
if (bind(s,(struct sockaddr *)name,sizeof(&name))==-1){
	printf("Cannot bind socket.\n");
	exit(1);
}
/* Listen */
if (listen(s,3)==-1){
	printf("Error in listen.\n");
	exit(1);
}
/* Accept */

while(1){
	if ((c=accept(s,(struct sockaddr *)name,&addrlen))==-1){
		printf("Error in accept\n");
		exit(1);
	}
	/* FORK */
	if ((pid=fork())==-1){
		printf("Error in fork.\n");
		close(s); close(c);
		exit(1);
	}
	if (pid==0){
		int sum,num1,num2;
		close(s);
		if (recv(c,buffer,250,0)==-1){
			printf("Error while receiving data.\n");
			exit(1);
		}
		sscanf(buffer,"%d %d",&num1,&num2);
		printf("num1==>%d, num2==>%d\n",num1,num2);
		sum=num1+num2;
		sprintf(buffer,"%d",sum);
		if (send(c,buffer,250,0)==-1){
			printf("Error in sending buffer.\n");
			exit(1);
		}
		exit(0);
	}
	else{
		close(c);
		wait(NULL);
	}

}


	
}
