#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>
#include <netdb.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <sys/socket.h>
#define PORT 7777

int main(int argc, char *argv[]) {
 int sockfd;
 struct hostent *he;
 struct sockaddr_in their_addr; 
 char *cp;
 int p1, p2, result; 

 if (argc != 4) {
 	printf("Parametre control yapiliyor\n");
  	fprintf(stderr, "usage: client <hostname> <param1> <param2>\n");
  	exit(1);
 };
  
 p1 = atoi(argv[2]);
 p2 = atoi(argv[3]);
 printf("Numbers to be added: %d %d",p1,p2);

 if ((he=gethostbyname(argv[1])) == NULL){ 
 	perror("gethostbyname");
      	exit(1);
 }; 

 if ((sockfd = socket(AF_INET, SOCK_STREAM, 0)) == -1){
 	perror("socket");
 	exit(1);
 };

 their_addr.sin_family=AF_INET;  
 their_addr.sin_port=htons(PORT);  
 their_addr.sin_addr= *((struct in_addr *)he->h_addr);
 bzero(&(their_addr.sin_zero),8);    

 if (connect(sockfd,(struct sockaddr *)&their_addr,sizeof(struct sockaddr))== -1){
 	perror("connect");
 	exit(1);
 };

 if (send(sockfd,&p1,sizeof(int),0)== -1)
 	perror("send");                                 

 if (send(sockfd,&p2,sizeof(int),0)== -1)
 	perror("send");                                 

 if ((recv(sockfd,&result,sizeof(int),0))== -1){
 	perror("recv");
 	exit(1);
 };

 printf("\nResult             : %d\n", result);
 
 close(sockfd);
 return 0;
}

