#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <sys/file.h>
#define PIPE "/tmp/mypipe"

int main(int argc, char *argv[]){
 int fd;
 int p1=0;
 int p2=0;
 int result=0; 

 unlink(PIPE);
 if (argc != 3){
 	fprintf(stderr,"Usage: client <p1> <p2>\n");
 	exit(1);
 };
 p1 = atoi(argv[1]);
 p2 = atoi(argv[2]);
 printf("Numbers to be added: %d %d",p1,p2);
 unlink(PIPE);

 if (mknod(PIPE,S_IFIFO,0)== -1){
 	perror("mknod");
 	exit(1);
 };

 chmod(PIPE,0660);

 fd= open(PIPE,O_WRONLY);
 if (write(fd,&p1,sizeof(int))== -1)
 	perror("write");                                 
 sleep(3);

 fd= open(PIPE,O_WRONLY);
 if (write(fd,&p2,sizeof(int))== -1)
 	perror("write");                                 
 sleep(3);

 fd= open(PIPE,O_RDONLY);
 if (read(fd,&result,sizeof(int))== -1){
 	perror("read");
 	exit(1);
 };
 printf("\nResult:		   : %d\n",result);
 
 close(fd);
 return 0;
}

